---
title: Manipulating video using canvas
slug: Web/API/Canvas_API/Manipulating_video_using_canvas
tags:
  - API
  - Canvas
  - Chroma-Key
  - Editing
  - Guide
  - Manipulating
  - Video
  - effects
---
<div>{{CanvasSidebar}}</div>

<div class="summary">
<p>By combining the capabilities of the <a class="internal" href="/en-US/docs/Web/HTML/Element/video" title="En/HTML/Element/Video"><code>video</code></a> element with a <a class="internal" href="/en-US/docs/Web/HTML/Element/canvas" title="En/Canvas"><code>canvas</code></a>, you can manipulate video data in real time to incorporate a variety of visual effects to the video being displayed. This tutorial demonstrates how to perform chroma-keying (also known as the "green screen effect") using JavaScript code.</p>
</div>

<p>{{EmbedGHLiveSample('dom-examples/canvas/chroma-keying/index.html', 700, 400) }}</p>

<h2 id="The_document_content">The document content</h2>

<p>The HTML document used to render this content is shown below.</p>

<pre>&lt;!DOCTYPE html&gt;
&lt;html&gt;
  &lt;head&gt;
    &lt;style&gt;
      body {
        background: black;
        color:#CCCCCC;
      }
      #c2 {
        background-image: url(media/foo.png);
        background-repeat: no-repeat;
      }
      div {
        float: left;
        border :1px solid #444444;
        padding:10px;
        margin: 10px;
        background:#3B3B3B;
      }
    &lt;/style&gt;
  &lt;/head&gt;

  &lt;body&gt;
    &lt;div&gt;
      &lt;video id="video" src="media/video.mp4" controls="true" crossorigin="anonymous"/&gt;
    &lt;/div&gt;
    &lt;div&gt;
      &lt;canvas id="c1" width="160" height="96"&gt;&lt;/canvas&gt;
      &lt;canvas id="c2" width="160" height="96"&gt;&lt;/canvas&gt;
    &lt;/div&gt;
  &lt;script type="text/javascript" src="processor.js"&gt;&lt;/script&gt;
  &lt;/body&gt;
&lt;/html&gt;
</pre>

<p>The key bits to take away from this are:</p>

<ol>
 <li>This document establishes two <a class="internal" href="/en-US/docs/Web/HTML/Element/canvas" title="En/Canvas"><code>canvas</code></a> elements, with the IDs <code>c1</code> and <code>c2</code>.  Canvas <code>c1</code> is used to display the current frame of the original video, while <code>c2</code> is used to display the video after performing the chroma-keying effect; <code>c2</code> is preloaded with the still image that will be used to replace the green background in the video.</li>
 <li>The JavaScript code is imported from a script named <code>processor.js</code>.</li>
</ol>

<h2 id="The_JavaScript_code">The JavaScript code</h2>

<p>The JavaScript code in <code>processor.js</code> consists of three methods.</p>

<h3 id="Initializing_the_chroma-key_player">Initializing the chroma-key player</h3>

<p>The <code>doLoad()</code> method is called when the XHTML document initially loads.  This method's job is to prepare the variables needed by the chroma-key processing code, and to set up an event listener so we can detect when the user starts playing the video.</p>

<pre class="brush: js">  var processor;

  processor.doLoad = function doLoad() {
    this.video = document.getElementById('video');
    this.c1 = document.getElementById('c1');
    this.ctx1 = this.c1.getContext('2d');
    this.c2 = document.getElementById('c2');
    this.ctx2 = this.c2.getContext('2d');
    let self = this;
    this.video.addEventListener('play', function() {
        self.width = self.video.videoWidth / 2;
        self.height = self.video.videoHeight / 2;
        self.timerCallback();
      }, false);
  },
</pre>

<p>This code grabs references to the elements in the XHTML document that are of particular interest, namely the <code>video</code> element and the two <code>canvas</code> elements.  It also fetches references to the graphics contexts for each of the two canvases.  These will be used when we're actually doing the chroma-keying effect.</p>

<p>Then <code>addEventListener()</code> is called to begin watching the <code>video</code> element so that we obtain notification when the user presses the play button on the video.  In response to the user beginning playback, this code fetches the width and height of the video, halving each (we will be halving the size of the video when we perform the chroma-keying effect), then calls the <code>timerCallback()</code> method to start watching the video and computing the visual effect.</p>

<h3 id="The_timer_callback">The timer callback</h3>

<p>The timer callback is called initially when the video starts playing (when the "play" event occurs), then takes responsibility for establishing itself to be called periodically in order to launch the keying effect for each frame.</p>

<pre class="brush: js">  processor.timerCallback = function timerCallback() {
    if (this.video.paused || this.video.ended) {
      return;
    }
    this.computeFrame();
    let self = this;
    setTimeout(function() {
        self.timerCallback();
      }, 0);
  },
</pre>

<p>The first thing the callback does is check to see if the video is even playing; if it's not, the callback returns immediately without doing anything.</p>

<p>Then it calls the <code>computeFrame()</code> method, which performs the chroma-keying effect on the current video frame.</p>

<p>The last thing the callback does is call <code>setTimeout()</code> to schedule itself to be called again as soon as possible.  In the real world, you would probably schedule this to be done based on knowledge of the video's frame rate.</p>

<h3 id="Manipulating_the_video_frame_data">Manipulating the video frame data</h3>

<p>The <code>computeFrame()</code> method, shown below, is responsible for actually fetching a frame of data and performing the chroma-keying effect.</p>

<pre class="brush: js">  processor.computeFrame = function computeFrame() {
    this.ctx1.drawImage(this.video, 0, 0, this.width, this.height);
    let frame = this.ctx1.getImageData(0, 0, this.width, this.height);
    let l = frame.data.length / 4;

    for (let i = 0; i &lt; l; i++) {
      let r = frame.data[i * 4 + 0];
      let g = frame.data[i * 4 + 1];
      let b = frame.data[i * 4 + 2];
      if (g &gt; 100 &amp;&amp; r &gt; 100 &amp;&amp; b &lt; 43)
        frame.data[i * 4 + 3] = 0;
    }
    this.ctx2.putImageData(frame, 0, 0);
    return;
  }
</pre>

<p>When this routine is called, the video element is displaying the most recent frame of video data, which looks like this:</p>

<p><img alt="video.png" class="default internal" src="/@api/deki/files/3282/=video.png" style="height: 192px; width: 320px;"></p>

<p>In line 2, that frame of video is copied into the graphics context <code>ctx1</code> of the first canvas, specifying as the height and width the values we previously saved to draw the frame at half size.  Note that you can pass the video element into the context's <code>drawImage()</code> method to draw the current video frame into the context.  The result is:</p>

<p><img alt="sourcectx.png" class="default internal" src="/@api/deki/files/3284/=sourcectx.png" style="height: 96px; width: 160px;"></p>

<p>Line 3 fetches a copy of the raw graphics data for the current frame of video by calling the <code>getImageData()</code> method on the first context.  This provides raw 32-bit pixel image data we can then manipulate.  Line 4 computes the number of pixels in the image by dividing the total size of the frame's image data by four.</p>

<p>The <code>for</code> loop that begins on line 6 scans through the frame's pixels, pulling out the red, green, and blue values for each pixel, and compares the values against predetermined numbers that are used to detect the green screen that will be replaced with the still background image imported from <code>foo.png</code>.</p>

<p>Every pixel in the frame's image data that is found that is within the parameters that are considered to be part of the green screen has its alpha value replaced with a zero, indicating that the pixel is entirely transparent.  As a result, the final image has the entire green screen area 100% transparent, so that when it's drawn into the destination context in line 13, the result is an overlay onto the static backdrop.</p>

<p>The resulting image looks like this:</p>

<p><img alt="output.png" class="default internal" src="/@api/deki/files/3283/=output.png" style="height: 96px; width: 161px;"></p>

<p>This is done repeatedly as the video plays, so that frame after frame is processed and displayed with the chroma-key effect.</p>

<p><a class="external" href="https://github.com/mdn/dom-examples/tree/master/canvas/chroma-keying" title="https://developer.mozilla.org/editor/fckeditor/core/editor/samples/video/chroma-key/index.xhtml">View the full source for this example</a>.</p>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/Media">Web media technologies</a></li>
 <li><a href="/en-US/docs/Web/Media/Formats">Guide to media types and formats on the web</a></li>
 <li><a href="/en-US/docs/Learn/HTML/Multimedia_and_embedding/Video_and_audio_content">Learning area: Video and audio content</a></li>
</ul>
